#include "OS_Semaphore.h"
#include "Prefix.h"
#include <Windows.h>

namespace EARTH {
namespace OS {

Semaphore::Semaphore(int count)
	: mHandle(NULL)
{
	_ASSERTE(mHandle == NULL);
	_ASSERTE(0 <= count);
	mHandle = ::CreateSemaphore(NULL, count, (static_cast<uint>(1)<<31)-1, NULL);
}

Semaphore::~Semaphore()
{
	if (mHandle) {
		BOOL b = ::CloseHandle(mHandle);
		_ASSERTE(b);
		mHandle = NULL;
	}
}

bool Semaphore::IsValid() const
{
    bool b = (mHandle != NULL);
	return b;
}

void Semaphore::Acquire()
{
	_ASSERTE(mHandle);
	DWORD result = ::WaitForSingleObject(mHandle, INFINITE);
	_ASSERTE(result == WAIT_OBJECT_0);
}

void Semaphore::Release()
{
	_ASSERTE(mHandle);
	BOOL b = ::ReleaseSemaphore(mHandle, 1, NULL);
	_ASSERTE(b);
}

}
}
