#include "Memory.h"
#include "Prefix.h"
#include <Windows.h>

namespace EARTH {
namespace Memory {

void *Alloc(uint size)
{
	_ASSERTE((size % SIZE) == 0);

	uint type = MEM_COMMIT;
	#if defined(_DEBUG) && defined(_WIN64)
		type |= MEM_TOP_DOWN;
	#endif

	void *ptr = ::VirtualAlloc(NULL, size, type, PAGE_READWRITE);
	return ptr;
}

void Free(void *ptr)
{
	_ASSERTE(ptr);
	BOOL	b = ::VirtualFree(ptr, 0, MEM_RELEASE);
	_ASSERTE(b);
}

}
}
