#ifndef _PCI_Bus_H
#define _PCI_Bus_H

#include "PCI.h"
#include "Prefix_.h"
#include "EARTH_PT.h"

namespace EARTH {
namespace PCI {
	class Bus {
	public:
		virtual ~Bus() {}
		virtual status Init() = 0;
		virtual status ScanDevice(PT::Bus::DeviceInfo *deviceInfoPtr, uint *deviceInfoCount, uint maxBadBitCount) = 0;
		virtual status WriteConfig(uint bus, uint slot, uint function, uint address, const void *data, uint size) = 0;
		virtual status ReadConfig (uint bus, uint slot, uint function, uint address,       void *data, uint size) = 0;
		virtual void *Handle() const = 0;
};

}
}

#endif
