#ifndef _PCI_Device_H
#define _PCI_Device_H

#include "Prefix_.h"
#include "PCI.h"

namespace EARTH {
namespace PCI {
	class Device {
	public:
		virtual status Init() = 0;

		virtual void Delete() = 0;

		virtual	status WriteConfig(uint address, const void *data, uint size = 4) = 0;
		virtual	status ReadConfig (uint address,       void *data, uint size = 4) = 0;

		virtual	void WriteMemory(uint address, const void *data, uint size = 4) = 0;
		virtual	void ReadMemory (uint address,       void *data, uint size = 4) = 0;

		virtual status SetReset(uint address, uint data, bool callWinDriver = true) = 0;

		virtual	uint ID() const = 0;

	protected:
		virtual ~Device() {}
	};
}
}

#endif
